/* vim: set sw=4 sts=4 et foldmethod=syntax : */

/*
 * Copyright (c) 2009 Ciaran McCreesh
 *
 * This file is part of the Paludis package manager. Paludis is free software;
 * you can redistribute it and/or modify it under the terms of the GNU General
 * Public License version 2, as published by the Free Software Foundation.
 *
 * Paludis is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <paludis/args/escape.hh>
#include <sstream>

using namespace paludis;
using namespace paludis::args;

const std::string
paludis::args::escape(const std::string & s)
{
    std::stringstream result;
    for (std::string::const_iterator c(s.begin()), c_end(s.end()) ;
            c != c_end ; ++c)
    {
        if ((*c >= 'a' && *c <= 'z') ||
                (*c >= 'A' && *c <= 'Z') ||
                (*c >= '0' && *c <= '9') ||
                *c == '-' ||
                *c == '_')
            result << *c;
        else
            result << '\\' << *c;
    }

    return result.str();
}

