/* vim: set ro : */

/* ******************************************************** */
/* THIS IS A GENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY */
/* ******************************************************** */

        /**
         * Options for a LineConfigFile.
         *
         * \see LineConfigFile
         * \see LineConfigFileOptions
         * \ingroup g_config_file
         */
enum LineConfigFileOption
{
    lcfo_disallow_continuations,  ///< Do not recognise line continuations
    lcfo_disallow_comments,  ///< Do not recognise comments
    lcfo_preserve_whitespace,  ///< Preserve exact whitespace
    lcfo_no_skip_blank_lines,  ///< Do not skip blank lines
    lcfo_allow_inline_comments,  ///< Allow inline comments. \since 0.28
    last_lcfo ///< Number of keys in paludis::LineConfigFileOption
};

/**
 * Write a LineConfigFileOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const LineConfigFileOption &) PALUDIS_VISIBLE;

        /**
         * Options for a KeyValueConfigFile.
         *
         * \see KeyValueConfigFile
         * \see KeyValueConfigFileOptions
         * \ingroup g_config_file
         */
enum KeyValueConfigFileOption
{
    kvcfo_disallow_continuations,  ///< Do not recognise line continuations
    kvcfo_disallow_comments,  ///< Do not recognise comments
    kvcfo_disallow_space_around_equals,  ///< Do not allow spaces around equals
    kvcfo_disallow_space_inside_unquoted_values,  ///< Do not allow spaces inside unquoted values
    kvcfo_disallow_single_quoted_strings,  ///< Do not allow single quoted strings
    kvcfo_disallow_double_quoted_strings,  ///< Do not allow double quoted strings
    kvcfo_disallow_unquoted_values,  ///< Do not allow unquoted values
    kvcfo_disallow_variables,  ///< Do not allow variable expansions
    kvcfo_disallow_source,  ///< Do not allow the source command
    kvcfo_preserve_whitespace,  ///< Do not strip trailing whitespace from values
    kvcfo_ignore_export,  ///< Accept and ignore the word export at the beginning of a line
    kvcfo_allow_inline_comments,  ///< Allow inline comments. \since 0.28
    kvcfo_allow_multiple_assigns_per_line,  ///< Allow A='b' B='c' (and unquoted if kvcfo_disallow_space_inside_unquoted_values). \since 0.28
    kvcfo_allow_sections,  ///< Allow [sections] \since 0.44
    kvcfo_allow_fancy_assigns,  ///< Allow ?= assignments \since 0.54.1
    kvcfo_allow_env,  ///< Allow ${ENV{blah}} \since 0.54.1
    kvcfo_ignore_single_quotes_inside_strings,  ///< Allow 'broken 'quoted' strings' (for libtool) \since 0.62.1
    last_kvcfo ///< Number of keys in paludis::KeyValueConfigFileOption
};

/**
 * Write a KeyValueConfigFileOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const KeyValueConfigFileOption &) PALUDIS_VISIBLE;

