/* vim: set ro : */

/* ******************************************************** */
/* THIS IS A GENERATED FILE. DO NOT EDIT THIS FILE DIRECTLY */
/* ******************************************************** */

        /**
         * An option for parsing a VersionSpec.
         *
         * \ingroup g_dep_spec
         * \since 0.38
         * \see VersionSpecOptions
         */
enum VersionSpecOption
{
    vso_flexible_dashes,  ///< Allow - and _ to be interchanged
    vso_flexible_dots,  ///< Allow - where . is allowed
    vso_ignore_case,  ///< Allow uppercase letters
    vso_letters_anywhere,  ///< Allow 1a2.3 etc
    vso_dotted_suffixes,  ///< Allow 1_alpha2.3
    vso_ignore_leading_v,  ///< Allow v1 etc
    vso_allow_leading_dot,  ///< Allow .1.2.3 etc
    last_vso ///< Number of keys in paludis::VersionSpecOption
};

/**
 * Write a VersionSpecOption to a stream.
 */
std::ostream &
operator<< (std::ostream &, const VersionSpecOption &) PALUDIS_VISIBLE;

/**
 * Read a VersionSpecOption from a stream.
 */
std::istream &
operator>> (std::istream &, VersionSpecOption &) PALUDIS_VISIBLE;

        /**
         * The type of a VersionSpec component.
         *
         * \ingroup g_dep_spec
         * \since 0.32
         */
enum VersionSpecComponentType
{
    vsct_ignore,  ///< An ignorable part (e.g. v in v1.23)
    vsct_alpha,  ///< An alpha part
    vsct_beta,  ///< A beta part
    vsct_pre,  ///< A pre part
    vsct_rc,  ///< An rc part
    vsct_empty,  ///< Used for ordering, not present in real versions.
    vsct_revision,  ///< A revision part
    vsct_patch,  ///< A patch part
    vsct_trypart,  ///< A try part
    vsct_letter,  ///< A letter (e.g. x in 1.2x)
    vsct_floatlike,  ///< A number to be compared using float-like rules
    vsct_number,  ///< A number (e.g. 1 or 2 in 1.2_pre3)
    vsct_scm,  ///< An scm part
    last_vsct ///< Number of keys in paludis::VersionSpecComponentType
};

/**
 * Write a VersionSpecComponentType to a stream.
 */
std::ostream &
operator<< (std::ostream &, const VersionSpecComponentType &) PALUDIS_VISIBLE;

